﻿using System;
using System.Diagnostics;
using System.Net;
using System.Net.Sockets;
using System.Runtime.InteropServices;
using System.Text;

class Program
{
    [DllImport("ws2_32.dll", SetLastError = true)]
    internal static extern IntPtr gethostbyaddr([In] ref int addr, [In] int len, [In] ProtocolFamily type);

    [DllImport("ws2_32.dll", CharSet = CharSet.Unicode, SetLastError = true)]
    internal static extern SocketError GetNameInfoW([In] byte[] sa, [In] int salen, [In, Out] StringBuilder host, [In] int hostlen, [In, Out] StringBuilder serv, [In] int servlen, [In] int flags);

    static void Main(string[] args)
    {
        Console.WriteLine(Process.GetCurrentProcess().Id);

        var dt = DateTime.Now;
        Console.WriteLine(dt);

        IPHostEntry entry = null;
        try
        {
             IPAddress address = IPAddress.Parse("192.168.102.5");

            // ResolveByGetHostByAddr(address);
            ResolveByBCL(address, out entry);
            // ResolveByGetNameInfo(address);

        } catch { }

        var elapsed = DateTime.Now - dt;
        Console.WriteLine(DateTime.Now + ", " + elapsed.TotalMilliseconds + ", " + entry);
    }

    private static void ResolveByGetNameInfo(IPAddress addr)
    {
        SocketAddress address = new IPEndPoint(addr, 0).Serialize();

        byte[] buf;
        CopySocketAddressBuffer(address, out buf);

        StringBuilder host = new StringBuilder(0x401);
        GetNameInfoW(buf, address.Size, host, host.Capacity, null, 0, (int)NI.NI_NAMEREQD);

        Console.WriteLine("ResolveByGetNameInfo: " + host.ToString());
    }

    public enum NI
    {
        NI_NOFQDN =      0x01,
        NI_NUMERICHOST=  0x02,
        NI_NAMEREQD   =  0x04,
        NI_NUMERICSERV = 0x08,
        NI_DGRAM       = 0x10,
    }

    private static void CopySocketAddressBuffer(SocketAddress address, out byte[] buf)
    {
        buf = new byte[address.Size];
        for (int i = 0; i < address.Size; i ++)
        {
            buf[i] = address[i];
        }
    }

    private static void ResolveByBCL(IPAddress address, out IPHostEntry entry)
    {
        entry = System.Net.Dns.GetHostByAddress(address);
    }

    private static void ResolveByGetHostByAddr(IPAddress address)
    {
        int addr = (int)address.Address;
        IntPtr nativePointer = gethostbyaddr(ref addr, Marshal.SizeOf(typeof(int)), ProtocolFamily.InterNetwork);
    }
}
